#include <stdio.h>
#include <stdlib.h>

unsigned char checksum (unsigned char *ptr, size_t sz) {
    unsigned char chk = 0;
    while (sz-- != 0)
        chk -= *ptr++;
    return chk;
}

int main(int argc, char* argv[])
{
    FILE *fptr;

    if ((fptr = fopen(argv[1],"rb")) == NULL)
    {
        printf("Error opening file");
        exit(1);
    }

    fseek(fptr, 0, SEEK_END);
    long fsize = ftell(fptr);
    fseek(fptr, 0, SEEK_SET);

    printf("File size = %d\n", fsize);

    unsigned char magicgop[] = { 0x55, 0xAA };
    unsigned char vbios[fsize];

    fread(vbios, fsize, 1, fptr);

    if(vbios[0x00] == magicgop[0x00] && vbios[0x01] == magicgop[0x01])
    {
        printf("Found magic bytes at the start of the file\n");
        unsigned char chksumresult = checksum (vbios, fsize-1); // this assumes that the checksum byte is present
        printf("Calculated checksum = 0x%02x\n", chksumresult);
        printf("Found checksum = 0x%02x\n", vbios[fsize-1]);
        if (chksumresult == vbios[fsize-1])
        {
            printf("Checksum is correct!\n");
        } else
        {
            printf("Checksum is incorrect!\n");
        }
    }
    
    return(0);
}
